<link rel="import" href="../../polymer/polymer-element.html" />

<dom-module id="buscador-element">
    <template>
        <link rel="stylesheet" href="bulma.min.css" />
        <label for="filtro">Filtrar empleados:</label>
        <input
            type="search"
            id="filtro"
            class="input"
            placeholder="Nombre o apellido..."
            value="{{criterio::input}}"
        />
    </template>

    <script>
        class BuscadorElement extends Polymer.Element {
            static get is() {
                return "buscador-element";
            }
            static get properties() {
                return {
                    criterio: {
                        type: String,
                        notify: true,
                    },
                    listaEmpleados: {
                        type: Array,
                    },
                };
            }
            ready() {
                super.ready();
                this.addEventListener("criterio-changed", this.filtrar);
            }

            set empleados(value) {
                this.listaEmpleados = value;
            }

            filtrar() {
                const busqueda = new RegExp(this.criterio, "i");

                let nuevaLista;
                if (this.criterio) {
                    nuevaLista = this.listaEmpleados.filter(({ employee_name }) => {
                        const nombreCompleto = employee_name.split(" ");
                        const [nombre, apellido] = nombreCompleto;
                        return busqueda.test(nombre) || busqueda.test(apellido);
                    });
                } else {
                    nuevaLista = this.listaEmpleados;
                }

                this.dispatchEvent(
                    new CustomEvent("filtrados", {
                        detail: nuevaLista,
                        bubbles: true,
                        composed: true,
                    })
                );
            }
        }

        window.customElements.define(BuscadorElement.is, BuscadorElement);
    </script>
</dom-module>
